// Author: Pete Kirkham
//
// quad store core utils.
//
#ifndef _CORE_UTILS_H_
#define _CORE_UTILS_H_

#define KiB (1024)
#define MiB (1024*1024)
#define GiB (1024*1024*1024)

#define SHUFFLE_EPI32(a,b,c,d)  (((((((3-a) << 2) | (3-b)) << 2) | (3-c)) << 2) | (3-d))
#define SPREAD_EPI32(a)         SHUFFLE_EPI32(a, a, a, a)

inline unsigned int     mix (unsigned int c)
{
    // Bob Jenkin's mix function
	unsigned int a,b;
	a = b = 0x7a915b7e;
	a -= b; a -= c; a ^= (c>>13);
	b -= c; b -= a; b ^= (a<<8);
	c -= a; c -= b; c ^= (b>>13);
	a -= b; a -= c; a ^= (c>>12);
	b -= c; b -= a; b ^= (a<<16);
	c -= a; c -= b; c ^= (b>>5);
	a -= b; a -= c; a ^= (c>>3);
	b -= c; b -= a; b ^= (a<<10);
	c -= a; c -= b; c ^= (b>>15);
	return c;
}

#endif // _CORE_UTILS_H_
